/*
This is part of Screenbar, which is based in part on the Litestep
shell source code.

Copyright (C) 2008-2009 Jim Babcock
Copyright (C) 1997-2009 The LiteStep Development Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#pragma once

class BranchElement
	:public LayoutElement
{
public:
	BranchElement(string prefix);
	~BranchElement();
	
	ElementSize getLength(const LayoutCacheNode *node);
	void getChildren(LayoutCacheNode *node, vector<LayoutLocation> &outChildren);
	
	struct BranchExpression {
		virtual bool evaluate(const ElementContext *context)=0;
	};
	
protected:
	struct Branch {
		BranchExpression *condition;
		LayoutElement *element;
	};
	vector<Branch> branches;
	
	LayoutElement *getBranch(const ElementContext *context);
	Branch parseBranch(const string &prefix);
	BranchExpression *parseExpression(const char *&pos);
	BranchExpression *parseUnaryExpression(const char *&pos);
	BranchExpression *parseLeafExpression(const string &expr);
};

